using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using GDIPac;

namespace GDIPac
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.PictureBox pictureBox1;
		private System.Windows.Forms.Button btnStart;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.Label lblScore;
		private System.Windows.Forms.Timer timer1;
		private System.Windows.Forms.GroupBox groupBox2;
		private System.Windows.Forms.Label lblLives;
		private System.ComponentModel.IContainer components;

		private bool _isPaused;
		private bool IsPaused
		{
			get{ return _isPaused; }
		}

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			this.KeyUp += new System.Windows.Forms.KeyEventHandler(NetTrix_KeyUp);
			this.KeyDown += new System.Windows.Forms.KeyEventHandler(NetTrix_KeyDown);
			this.Deactivate += new EventHandler(Form1_Deactivate);
			this.btnStart.KeyDown += new System.Windows.Forms.KeyEventHandler(NetTrix_KeyDown);
			this.pictureBox1.Paint += new PaintEventHandler(pictureBox1_Paint);
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Form1));
			this.pictureBox1 = new System.Windows.Forms.PictureBox();
			this.btnStart = new System.Windows.Forms.Button();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.lblScore = new System.Windows.Forms.Label();
			this.timer1 = new System.Windows.Forms.Timer(this.components);
			this.groupBox2 = new System.Windows.Forms.GroupBox();
			this.lblLives = new System.Windows.Forms.Label();
			this.groupBox1.SuspendLayout();
			this.groupBox2.SuspendLayout();
			this.SuspendLayout();
			// 
			// pictureBox1
			// 
			this.pictureBox1.BackColor = System.Drawing.Color.Transparent;
			this.pictureBox1.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("pictureBox1.BackgroundImage")));
			this.pictureBox1.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.pictureBox1.Location = new System.Drawing.Point(0, 0);
			this.pictureBox1.Name = "pictureBox1";
			this.pictureBox1.Size = new System.Drawing.Size(276, 260);
			this.pictureBox1.TabIndex = 0;
			this.pictureBox1.TabStop = false;
			// 
			// btnStart
			// 
			this.btnStart.Location = new System.Drawing.Point(280, 232);
			this.btnStart.Name = "btnStart";
			this.btnStart.Size = new System.Drawing.Size(80, 23);
			this.btnStart.TabIndex = 0;
			this.btnStart.Text = "Start";
			this.btnStart.Click += new System.EventHandler(this.btnStart_Click);
			// 
			// groupBox1
			// 
			this.groupBox1.Controls.Add(this.lblScore);
			this.groupBox1.Location = new System.Drawing.Point(280, 0);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(80, 40);
			this.groupBox1.TabIndex = 1;
			this.groupBox1.TabStop = false;
			this.groupBox1.Text = "Score";
			// 
			// lblScore
			// 
			this.lblScore.Location = new System.Drawing.Point(8, 16);
			this.lblScore.Name = "lblScore";
			this.lblScore.RightToLeft = System.Windows.Forms.RightToLeft.Yes;
			this.lblScore.Size = new System.Drawing.Size(64, 16);
			this.lblScore.TabIndex = 2;
			this.lblScore.Text = "0";
			// 
			// timer1
			// 
			this.timer1.Interval = 150;
			this.timer1.Tick += new System.EventHandler(this.timer1_Tick);
			// 
			// groupBox2
			// 
			this.groupBox2.Controls.Add(this.lblLives);
			this.groupBox2.Location = new System.Drawing.Point(280, 48);
			this.groupBox2.Name = "groupBox2";
			this.groupBox2.Size = new System.Drawing.Size(80, 40);
			this.groupBox2.TabIndex = 3;
			this.groupBox2.TabStop = false;
			this.groupBox2.Text = "Lives";
			// 
			// lblLives
			// 
			this.lblLives.Location = new System.Drawing.Point(8, 16);
			this.lblLives.Name = "lblLives";
			this.lblLives.RightToLeft = System.Windows.Forms.RightToLeft.Yes;
			this.lblLives.Size = new System.Drawing.Size(64, 16);
			this.lblLives.TabIndex = 2;
			this.lblLives.Text = "0";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(368, 260);
			this.Controls.Add(this.groupBox1);
			this.Controls.Add(this.btnStart);
			this.Controls.Add(this.pictureBox1);
			this.Controls.Add(this.groupBox2);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "Form1";
			this.Text = "GDIPac by Nick Sabalausky";
			this.groupBox1.ResumeLayout(false);
			this.groupBox2.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main()
		{
			Application.Run(new Form1());
		}

		private void NetTrix_KeyUp(object sender, KeyEventArgs e)
		{
			Keyboard.GetInstance().SetKeyUp(e.KeyCode);
		}

		private void NetTrix_KeyDown(object sender, KeyEventArgs e)
		{
			if(Game.GetInstance().IsRunning && e.KeyCode == Keys.Escape)
			{
				if(IsPaused)
					Unpause();
				else
					Pause();

				Game.GetInstance().RedrawScreen();
			}

			Keyboard.GetInstance().SetKeyDown(e.KeyCode);
		}

		private void pictureBox1_Paint(object sender, PaintEventArgs e)
		{
			Game.GetInstance().RedrawScreen();
		}

		  // NOTE: Start button doubles as reset button
		private void btnStart_Click(object sender, System.EventArgs e)
		{
			btnStart.Text = "Restart";
			this.BackgroundImage = null;

			Game.GetInstance().Start(pictureBox1, lblScore, lblLives);
			timer1.Start();
			Unpause();
		}

		private void timer1_Tick(object sender, System.EventArgs e)
		{
			Game.GetInstance().DoFrame();

			  // If game stopped itself, it's because it's Game Over
			if(!Game.GetInstance().IsRunning)
			{
				timer1.Enabled = false;
				btnStart.Text = "Start";
				btnStart.Enabled = true;
				this.Text = "GDIPac  *Game Over*";
				Game.GetInstance().DisplayGameOver();
			}
		}

		private void Form1_Deactivate(object sender, EventArgs e)
		{
			if(Game.GetInstance().IsRunning)
			  Pause();
		}

		private void Pause()
		{
			_isPaused = true;
			timer1.Enabled = false;
			this.Text = "GDIPac  *Paused* - Press 'Esc' to Continue";
			btnStart.Enabled = true;
		}

		private void Unpause()
		{
			_isPaused = false;
			timer1.Enabled = true;
			this.Text = "GDIPac by Nick Sabalausky";
			btnStart.Enabled = false;
		}
	}
}
