using System;
using System.IO;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Text;

namespace GDIPac
{
	/// <summary>
	/// Summary description for ImageSet.
	/// </summary>
	public class ImageSet
	{
		private Image[,] images = new Image[4,2];

		public void SetImage(Direction direction, string anim1BitmapFilename, string anim2BitmapFilename)
		{
			SetImage(direction, 0, anim1BitmapFilename);
			SetImage(direction, 1, anim2BitmapFilename);
		}

		public void SetImage(Direction direction, int animFrame, string animBitmapFilename)
		{
			Bitmap bmp;

			if(animFrame != 1)
				animFrame = 0;
			
			bmp = (Bitmap)Bitmap.FromFile(animBitmapFilename);
			bmp.MakeTransparent(Color.FromArgb(192, 192, 192));
			images[(int)direction, animFrame] = bmp;
		}

		public Image GetImage(Direction direction, int animFrame)
		{
			if(animFrame == 1)
				return images[(int)direction, 1];
			else
				return images[(int)direction, 0];
		}

		public ImageSet()
		{
		}
	}
}
