using System;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace GDIPac
{
	/// <summary>
	/// 
	/// </summary>
	public class Keyboard
	{
		 // This class is a Singleton
		#region Singleton Stuff
		private Keyboard() {}
		private static Keyboard _instance=null;
		public static Keyboard GetInstance()
		{
			if(_instance == null)
				_instance = new Keyboard();

			return _instance;
		}
		#endregion

		// True if key is currently down
		#region Keys
		private bool _keyUp=false;
		private bool _keyDown=false;
		private bool _keyLeft=false;
		private bool _keyRight=false;
		#endregion
		// True if key is currently down
		#region Key Accessors
		public bool KeyUp
		{
			get{ return _keyUp; }
		}
		public bool KeyDown
		{
			get{ return _keyDown; }
		}
		public bool KeyLeft
		{
			get{ return _keyLeft; }
		}
		public bool KeyRight
		{
			get{ return _keyRight; }
		}
		#endregion

		// Returns: true if it's a key Keyboard cares about, false otherwise
		public bool SetKeyDown(Keys keyCode)
		{
			switch(keyCode)
			{
				case Keys.Up:
					_keyUp = true;
					return true;

				case Keys.Down:
					_keyDown = true;
					return true;

				case Keys.Left:
					_keyLeft = true;
					return true;

				case Keys.Right:
					_keyRight = true;
					return true;

				default:
					return false;
			}
		}

		// Returns: true if it's a key Keyboard cares about, false otherwise
		public bool SetKeyUp(Keys keyCode)
		{
			switch(keyCode)
			{
				case Keys.Up:
					_keyUp = false;
					return true;

				case Keys.Down:
					_keyDown = false;
					return true;

				case Keys.Left:
					_keyLeft = false;
					return true;

				case Keys.Right:
					_keyRight = false;
					return true;

				default:
					return false;
			}
		}
	}
}
