using System;

namespace GDIPac
{
	public enum Direction {North=0, South, East, West, None};

	/// <summary>
	/// Summary description for Util.
	/// </summary>
	public class Util
	{
		public static Random random = new Random();

		public static int GetAdjacentX(int x, Direction direction)
		{
			switch(direction)
			{
				case Direction.West:
					return x-1;

				case Direction.East:
					return x+1;

				default:
					return x;
			}
		}

		public static int GetAdjacentY(int y, Direction direction)
		{
			switch(direction)
			{
				case Direction.North:
					return y-1;

				case Direction.South:
					return y+1;

				default:
					return y;
			}
		}

		public static Direction GetReverseDirection(Direction direction)
		{
			switch(direction)
			{
				case Direction.North:
					return Direction.South;

				case Direction.South:
					return Direction.North;

				case Direction.East:
					return Direction.West;

				case Direction.West:
					return Direction.East;

				case Direction.None:
				default:
					return Direction.None;
			}
		}

		  // NOTE: This assumes that all sprites are 16x16 (Which is true in this game)
 		public static bool IsCollision(Sprite s1, Sprite s2)
		{
				 // Use 14 instead of 16 to effectively shrink the bounding boxes
			if( Math.Abs(s1.PixelsX - s2.PixelsX) < 14 &&
				Math.Abs(s1.PixelsY - s2.PixelsY) < 14 )
			{
				return true;
			}

			return false;
		}

		  // This really needs templates.  Too bad they're not supported in v1.1 of C#
		public delegate void TileActingDelgateV(int x, int y);
		public static void ApplyAdjacentV(TileActingDelgateV tileActingDelegate, int x, int y, Direction direction)
		{
			tileActingDelegate(GetAdjacentX(x, direction), GetAdjacentY(y, direction));
		}

		public delegate bool TileActingDelgateB(int x, int y);
		public static bool ApplyAdjacentB(TileActingDelgateB tileActingDelegate, int x, int y, Direction direction)
		{
			return tileActingDelegate(GetAdjacentX(x, direction), GetAdjacentY(y, direction));
		}
	}
}
